program interpo_check

  use statistics

  implicit none

  integer, parameter :: nx=101, ny=20

  integer :: i, j
  integer :: iy1(ny), iy2(ny)
  real :: x(nx), y(ny)

  x=(/((real(i)),i=1,nx)/)
  y=(/((real(j-1)*5+1),j=1,ny)/)

  call auto_interpo_search_1d( x, y, iy1 )

  do j=1,ny
     call interpo_search_1d( x, y(j), iy2(j) )
  end do

  write(*,'(a45)') "check result =   j  |  x  |  y  |  y1 |  y2 |"
  do j=1,ny
     write(*,'(a15,i5,a1,f5.0,a1,f5.0,a1,i5,a1,i5,a1)')  &
  &        "check point  = ", j, '|', x(iy2(j)), '|', y(j), '|', iy1(j), '|', iy2(j), '|'
  end do

end program interpo_check
